/*

*************************************************************************

ArmageTron -- Just another Tron Lightcycle Game in 3D.
Copyright (C) 2000  Manuel Moos (manuel@moosnet.de)

**************************************************************************

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
***************************************************************************

*/

#include "rSDL.h"

#ifndef ARMAGETRON_HUD_H
#define ARMAGETRON_HUD_H

extern REAL subby_SpeedGaugeSize, subby_SpeedGaugeLocX, subby_SpeedGaugeLocY;
extern REAL subby_BrakeGaugeSize, subby_BrakeGaugeLocX, subby_BrakeGaugeLocY;
extern REAL subby_RubberGaugeSize, subby_RubberGaugeLocX, subby_RubberGaugeLocY;
extern bool subby_ShowHUD, subby_ShowSpeedFastest, subby_ShowScore, subby_ShowAliveEnemies, subby_ShowPing, subby_ShowSpeedMeter, subby_ShowBrakeMeter, subby_ShowRubberMeter;
extern REAL subby_ScoreLocX, subby_ScoreLocY, subby_ScoreSize;
extern REAL subby_FastestLocX, subby_FastestLocY, subby_FastestSize;
extern REAL subby_AliveEnemiesLocX, subby_AliveEnemiesLocY, subby_AliveEnemiesSize;
extern REAL subby_PingLocX, subby_PingLocY, subby_PingSize;
extern bool showTime;
extern bool show24hour;
extern bool subby_SpeedGaugeBar, subby_BrakeGaugeBar, subby_RubberGaugeBar;

class gHudGauge;

// This is probably a case of YouMightNeedThis
class gHudWidget {
protected:
public:
    virtual void Render(gCycle *h) { return; };
};
class gHudWidgetContainer {
    gHudWidget *realwidget;
public:
    gHudWidgetContainer(gHudWidget *widget){
	realwidget = widget;
    };
    //Something is wrong with this... But I guess it is needed somehow
    /*~gHudWidgetContainer(){
	delete realwidget;
    };*/
    gHudWidget *GetWidget(){
	return (realwidget);
    };
};

class gHud {
public:
    gHud();

    // This should be removed when the hud is part of a real gui system
    static gHud* GetHud();

    void SetPlayer(ePlayer *player) { m_Player = player; };
    
    void RenderEnemies();
    void RenderPing();
    void RenderScore();
    void RenderFastest();
    void RenderFPS();
    // Deprecated, probably, just used to glue in to the old hud
    void RenderOld();

private:
    static gHud* _instance;

    float m_Size;
    ePlayer* m_Player;
    gHudGauge* m_RubberGauge;
    gHudGauge* m_SpeedGauge;
    gHudGauge* m_BrakeGauge;
    std::deque<gHudWidgetContainer> Widgets;

    //callback functions for subwidgets
    float cb_CurrentRubber(void) { return 0.5; };
    float cb_CurrentSpeed(void) { return 0.5; };
    float cb_CurrentBrakingReservoir(void) { return 0.5; };
};



#endif
